<?php // Copyright 2013-2014 Theo CMS http://theocms.com/. License GPLv3. Admin v1.8.
ob_start('ob_gzhandler');
define('THEO', 'admin');
require 'config.php';
include 'plugins.php';
session_start();
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta name="robots" content="noindex, nofollow" />
<title><?php echo $S['site']['value'].' '.$L['admin']; ?></title>
<link type="text/css" rel="stylesheet" href="theo-style.css" />
<link type="image/png" rel="icon" href="theo-favicon.png" />
</head><body>
<?php

// AUTHENTICATE
if (isset($_POST['loginpass'])) {
 $user = (isset($_POST['loginuser']) ? clean($_POST['loginuser'], 1) : '');
 $pass = md5(clean($_POST['loginpass'], 1));
 foreach ($U as $k => $u) if (in_array($pass, $u, TRUE)) $id = $k;
 if (isset($id) && (empty($S['loginu']['value']) || $user === $U[$id]['user'])) {
  session_regenerate_id(TRUE);
  $_SESSION['user'] = array('id'=>$id, 'group'=>$U[$id]['group'], 'sess'=>md5(session_id().$_SERVER['HTTP_USER_AGENT']));
 }
}

// AUTHENTICATED CONTENT
if (isset($_SESSION['user']) && $_SESSION['user']['sess'] === md5(session_id().$_SERVER['HTTP_USER_AGENT'])) {

// GENERATE ALERTS, FOOT LINKS
$alert = '';
$footlinks = '';
if (empty($_GET)) {
 $comheld = mysql_num_rows(mysql_query("SELECT id FROM ".$pre."comments WHERE allow=''"));
 if ($comheld) $alert .= '<a href="?commod=0">'.$L['held'].' '.$L['comments'].' ('.$comheld.')</a> | ';
 if (isset($plugins[0])) {
  foreach ($plugins as $plugin) {
   if (isset($plugin['panel'])) $footlinks .= '<a href="?plugin='.$plugin['panel'].'">'.$plugin['name'].'</a> | ';
  }
 }
 if ($_SESSION['user']['group'] === 'u_1' || $_SESSION['user']['group'] === 'u_2') $footlinks .= '<a href="?themes">'.$L['themes'].'</a> | ';
 $footlinks .= '<a href="?settings">'.$L['settings'].'</a>';
}

// PAGE OUTPUT
echo '<div id="wrap">
<div id="head">
<a href="'.$_SERVER['SCRIPT_NAME'].'"><h2>'.$S['site']['value'].'</h2></a><span>'.$alert.'<a href="?logout">'.$L['logout'].'</a></span>
</div><!--/head-->
<div id="container">'."\n";
$panel = strtok($_SERVER['QUERY_STRING'], '=');
switch ($panel) {

// LOGOUT
case 'logout':
$_SESSION['user'] = NULL;
session_destroy();
header('refresh:00;url='.$_SERVER['SCRIPT_NAME']);
break;

// PLUGIN PANEL
case 'plugin':
$_GET['plugin']();
break;

// SEARCH
case 'search':
echo '<h4>'.$L['searchres'].' "<i>'.$_POST['search'].'</i>"</h4>';
$row = mysql_query("SELECT id, title FROM posts WHERE (title LIKE '%".$_POST['search']."%' OR text LIKE '%".$_POST['search']."%')");
while ($res = mysql_fetch_assoc($row)) {
echo '<a href="?post=&edit='.$res['id'].'">'.$res['title'].'</a><br />';
}
if (mysql_num_rows($row) === 0) echo $L['noresult'].header('refresh:03;url='.$_SERVER['SCRIPT_NAME']);
break;

// CATEGORIES
case 'cat':
if (empty($_POST)) {
 $row = mysql_fetch_assoc(mysql_query("SELECT a.subcat, a.name, b.id AS bid, c.id AS cid FROM ".$pre."categories a LEFT JOIN ".$pre."categories b ON b.subcat=$_GET[edit] LEFT JOIN ".$pre."posts c ON c.category=$_GET[edit] WHERE a.id=$_GET[edit]"));
 echo '<h4>'.$L['edit'].' '.($row['subcat'] === '0' ? $L['cat'] : $L['subcat']).':</h4>
 <form class="editcat" method="post" action="?cat=&edit='.$_GET['edit'].'">
 <input type="text" name="catname" value="'.$row['name'].'" />
 '.($row['subcat'] === '0' ? '<input type="hidden" name="category" value="0" />' : dropdown($row['subcat'])).'
 <input type="submit" value="'.$L['save'].'" />
 '.(!$row['bid'] && !$row['cid'] ? '<input type="submit" name="remove" value="'.$L['remove'].'" />'."\n".'</form>' : '</form>');
 if ($row['subcat'] === '0') {
  echo "\n".'<br />'.$L['new'].' '.$L['subcat'].':
  <form class="editcat" method="post" action="?cat=&subid='.$_GET['edit'].'">
  <input type="text" name="catname" /> <input type="submit" value="'.$L['save'].'" />
  </form>';
 }
} else {
 if (isset($_POST['remove'])) {
  mysql_query("DELETE FROM ".$pre."categories WHERE id=$_GET[edit]");
 } else {
  $name = ($_POST['catname'] ? clean($_POST['catname']) : $L['no'].' '.$L['name']);
  $namesef = strtolower(str_replace(' ', '-', $name));
  $namesef = preg_replace('/[^a-z0-9-]/', '', $namesef);
  if (empty($_GET['edit'])) {
   mysql_query("INSERT INTO ".$pre."categories VALUES ('', $_GET[subid], '$namesef', '$name')");
  } else {
   mysql_query("UPDATE ".$pre."categories SET subcat=$_POST[category], namesef='$namesef', name='$name' WHERE id=$_GET[edit]");
  }
 }
 header('refresh:00;url='.$_SERVER['SCRIPT_NAME']);
}
break;

// Cases below have group permissions.
// POSTS
case 'post':
// Remove (if group 1 or 2, via form).
if (isset($_POST['remove'])) {
 mysql_query("DELETE a.*, b.* FROM ".$pre."posts a LEFT JOIN ".$pre."comments b ON b.post=$_GET[edit] WHERE a.id=$_GET[edit]");
 system('rm -rf ../'.$_POST['dir']);
 header('refresh:00;url='.$_SERVER['SCRIPT_NAME']);
} elseif (isset($_POST['save'])) {
  $pub = (empty($_POST['pub']) ? '' : '1');
  $title = ($_POST['title'] ? clean($_POST['title']) : $L['no'].' '.$L['title']);
  $titlesef = strtolower(str_replace(' ', '-', $title));
  $titlesef = preg_replace('/[^a-z0-9-]/', '', $titlesef);
  $showcom = (empty($_POST['showcom']) ? '' : '1');
  // Save new.
  if (empty($_GET['edit'])) {
   mysql_query("INSERT INTO ".$pre."posts VALUES ('', '$pub', $_POST[category], '$titlesef', '$title', '".clean($_POST['text'])."', NOW(), '".clean($_POST['tags'])."', '$showcom', '', '".$_SESSION['user']['id']."', '".clean($_POST['desc'])."', '".clean($_POST['kwords'])."')");
  // Save edit (if group 1, 2 or post author, via form).
  } else {
   mysql_query("UPDATE ".$pre."posts SET pub='$pub', category=$_POST[category], titlesef='$titlesef', title='$title', text='".clean($_POST['text'])."', date='$_POST[date]', tags='".clean($_POST['tags'])."', showcom='$showcom', closecom=closecom, editby='".$_SESSION['user']['id']."', mdesc='".clean($_POST['desc'])."', mkwords='".clean($_POST['kwords'])."' WHERE id=$_GET[edit]");
  }
  if (!empty($_FILES['upfile']['tmp_name'])) {
   if (!is_dir('../'.$_POST['dir'])) mkdir('../'.$_POST['dir'], 0755, TRUE);
   move_uploaded_file($_FILES['upfile']['tmp_name'], '../'.$_POST['dir'].'/'.basename($_FILES['upfile']['name']));
  }
  header('refresh:00;url='.(empty($_GET['edit']) ? $_SERVER['SCRIPT_NAME'] : ''));
} elseif (empty($_GET['edit'])) {
 // New form.
 $r = mysql_fetch_assoc(mysql_query("SHOW TABLE STATUS LIKE '".$pre."posts'"));
 $dir = 'th-files/'.date('Y').'/'.str_pad($r['Auto_increment'], 2, '0', STR_PAD_LEFT);
 form('0', '', '', ($_GET['post'] ? $_GET['post'] : '0'), '', '', '', '', ($_GET['post'] ? '1' : ''), $dir, '', $_SESSION['user']['id']);
} else {
 // Edit form.
 $r = mysql_fetch_assoc(mysql_query("SELECT * FROM ".$pre."posts WHERE id=$_GET[edit]"));
 $dir = 'th-files/'.substr($r['date'], 0, 4).'/'.str_pad($_GET['edit'], 2, '0', STR_PAD_LEFT);
 $rpath = mysql_fetch_assoc(mysql_query("SELECT a.namesef, b.namesef as parent FROM ".$pre."categories a LEFT JOIN ".$pre."categories b ON a.subcat=b.id WHERE a.id=$r[category]"));
 $sef = '../'.($rpath['parent'] ? $rpath['parent'].'/'.$rpath['namesef'].'/' : ($rpath['namesef'] ? $rpath['namesef'].'/' : '')).$r['titlesef'];
 form($r['pub'], $r['title'], $r['text'], $r['category'], $r['mdesc'], $r['mkwords'], $r['tags'], $r['date'], $r['showcom'], $dir, $sef, $r['editby']);
}
break;

// COMMENTS
case 'commod':
if (isset($_POST['close'])) mysql_query("UPDATE ".$pre."posts SET closecom=".($_GET['close'] ? 1 : "''")." WHERE id=$_GET[commod]");
if (isset($_POST['allow'])) mysql_query("UPDATE ".$pre."comments SET allow=".($_POST['allow'] === $L['hide'] ? "''" : 1)." WHERE id=$_GET[id]");
if (isset($_POST['remove'])) mysql_query("DELETE FROM ".$pre."comments WHERE id=$_GET[id]");
if (isset($_POST['save'])) mysql_query("UPDATE ".$pre."comments SET name='".clean($_POST['name'])."', email='".clean($_POST['email'])."', site='".clean($_POST['site'])."', date='$_POST[date]', comment='".clean($_POST['text'])."' WHERE id=$_GET[id]").header('refresh:00;url=?commod='.$_GET['commod'].'');
// Edit comment.
if (isset($_POST['edit'])) {
 $res = mysql_query("SELECT id, date, name, email, site, comment FROM ".$pre."comments WHERE id=$_GET[id]");
 echo '<div class="comhead"><h4>'.$L['edit'].' '.$L['comment'].'</h4> <a href="?commod='.$_GET['commod'].'">'.$L['back'].'</a></div>'."\n";
 while ($com = mysql_fetch_assoc($res)) {
  echo '<form class="editcom" method="post" action="?commod='.$_GET['commod'].'&id='.$com['id'].'">
  <div class="editcommeta">
  <b>'.$L['name'].'</b> <input type="text" name="name" value="'.$com['name'].'" /><br />
  <b>'.$L['email'].'</b> <input type="text" name="email" value="'.$com['email'].'" /><br />
  <b>'.$L['site'].'</b> <input type="text" name="site" value="'.$com['site'].'" /><br />
  <b>'.$L['date'].'</b> <input type="text" name="date" value="'.$com['date'].'" /><br />
  <input type="submit" name="save" value="'.$L['save'].'" />
  </div>
  <textarea name="text" rows="10" cols="">'.$com['comment'].'</textarea>
  </form>';
 }
// Query and form for unapproved or post comments.
} elseif ($_GET['commod'] === '0') {
 $res = mysql_query("SELECT a.id, a.allow, a.date, a.name, a.email, a.site, a.comment, b.title FROM ".$pre."comments a, ".$pre."posts b WHERE a.post=b.id AND a.allow='' ORDER BY a.id DESC");
 echo (mysql_num_rows($res) === 0 ? header('refresh:00;url='.$_SERVER['SCRIPT_NAME']) : '<h4>'.$L['unapp'].' '.$L['comments'].'</h4>');
} else {
 $res = mysql_query("SELECT a.id, a.allow, a.date, a.name, a.email, a.site, a.comment, b.title FROM ".$pre."comments a LEFT JOIN ".$pre."posts b ON b.id=a.post WHERE a.post=$_GET[commod] ORDER BY a.id DESC");
 if (mysql_num_rows($res) === 0) {
  echo $L['no'].' '.$L['comments'].header('refresh:01;url=?post=&edit='.$_GET['commod']);
 } else {
  $close = mysql_result(mysql_query("SELECT closecom FROM ".$pre."posts WHERE id=$_GET[commod]"), 0);
  echo '<div class="comhead"><h4>'.$L['post'].' '.$L['comments'].'</h4> <a href="?post=&edit='.$_GET['commod'].'">'.$L['back'].'</a>
  <form method="post" action="?commod='.$_GET['commod'].'&close='.($close ? '' : '1').'">
  <input type="submit" name="close" value="'.($close ? $L['open'] : $L['close']).'" />
  </form></div>';
 }
}
while ($com = mysql_fetch_assoc($res)) {
 echo "\n".'<form class="comment" method="post" action="?commod='.$_GET['commod'].'&id='.$com['id'].'">
 <div class="commeta">
 <b>'.$L['name'].':</b> '.$com['name'].'<br />
 <b>'.$L['email'].':</b> '.$com['email'].'<br />
 <b>'.$L['site'].':</b> '.$com['site'].'<br />
 <b>'.$L['date'].':</b> '.date('m/d/y g:ia', strtotime($com['date'])).'<br />
 <b>'.$L['post'].':</b> '.$com['title'].'
 </div>
 <span>'.nl2p($com['comment']).'</span>
 <div class="comopt">
 <input type="submit" name="allow" value="'.($com['allow'] ? $L['hide'] : $L['allow']).'" /><br />';
 // Limit edit and remove to group 1 and 2.
 if ($_SESSION['user']['group'] === 'u_1' || $_SESSION['user']['group'] === 'u_2') {
  echo '<input type="submit" name="edit" value="'.$L['edit'].'" /><br />
  <input type="button" value="'.$L['remove'].'" onclick="tog(\''.$com['id'].'\')" /><br />
  <input style="display:none;" id="'.$com['id'].'" type="submit" name="remove" value="'.$L['confirm'].'" />';
 }
 echo '</div>
 </form><div class="clear"></div><br />';
}
break;

// THEMES
case 'themes':
if ($_SESSION['user']['group'] === 'u_1' || $_SESSION['user']['group'] === 'u_2') {
 if (isset($_POST['set'])) copy('../th-themes/'.$_GET['name'].'/index.php', '../index.php');
 if (isset($_POST['rmfile'])) unlink('../th-themes/'.$_GET['name']);
 if (isset($_POST['rmfolder'])) {
  $delfiles = array_diff(scandir('../th-themes/'.$_GET['name']), array('.', '..'));
  foreach ($delfiles as $delfile) unlink('../th-themes/'.$_GET['name'].'/'.$delfile);
  rmdir('../th-themes/'.$_GET['name']);
 }
 if (isset($_POST['send']) && ($_FILES['uptheme']['tmp_name'])) {
  move_uploaded_file($_FILES['uptheme']['tmp_name'], '../th-themes/'.basename($_FILES['uptheme']['name']));
  $file = explode('.', $_FILES['uptheme']['name']);
  if (isset($file) && end($file) === 'gz') {
   $archive = new PharData('../th-themes/'.$_FILES['uptheme']['name']);
   $archive->decompress();
   $archive->extractTo('../th-themes/');
   unlink('../th-themes/'.$file[0].'.tar');
   unlink('../th-themes/'.$_FILES['uptheme']['name']);
  } elseif (isset($file) && end($file) === 'zip') {
   $archive = new ZipArchive;
   $archive->open('../th-themes/'.$_FILES['uptheme']['name']);
   $archive->extractTo('../th-themes/');
   $archive->close();
   unlink('../th-themes/'.$_FILES['uptheme']['name']);
  }
 }
 // Get current theme.
 $raw = file_get_contents('../index.php', NULL, NULL, 120, 500);
 $cur = explode('/', substr($raw, strpos($raw, 'th-themes/'), 30));
 $cur[1] = (empty($cur[1]) ? '' : rawurldecode($cur[1]));
 // Sort available themes from other folders and files.
 $names = array_diff(scandir('../th-themes/'), array('.', '..', $cur[1]));
 foreach ($names as $name) (is_file('../th-themes/'.$name.'/index.php') ? $themes[] = $name : $files[] = $name);
 // Current theme and upload form.
 echo '<h4>'.$L['themes'].':</h4>
 <div class="themes">
 '.$L['themecur'].': <b>'.$cur[1].'</b><br />
 <img src="../th-themes/'.$cur[1].'/'.$cur[1].'.png" alt="'.$L['no'].' '.$L['preview'].'" />
 <form class="themeup" method="post" enctype="multipart/form-data" action="">
 '.$L['themeup'].'<br />
 <input id="uptheme" name="uptheme" type="file" /><br />
 <input type="submit" name="send" value="'.$L['send'].'" />
 </form>';
 if ($cur[1] && filesize('../index.php') !== filesize('../th-themes/'.$cur[1].'/index.php')) {
  echo '<form method="post" action="" class="themeindex">';
  if (filectime('../index.php') > filectime('../th-themes/'.$cur[1].'/index.php')) {
   echo str_replace(array('<new>', '<old>'), array($L['site'], $L['themes']), $L['updateindex']).'<br />
   <input type="submit" name="update[themeindex]"';
  } else {
   echo str_replace(array('<new>', '<old>'), array($L['themes'], $L['site']), $L['updateindex']).'<br />
   <input type="submit" name="update[siteindex]"';
  }
  echo ' value="'.$L['update'].'" /></form>';
 }
 if (isset($_POST['update'])) {
  if (key($_POST['update']) === 'themeindex') {
   copy('../index.php', '../th-themes/'.$cur[1].'/index.php');
  } else {
   copy('../th-themes/'.$cur[1].'/index.php', '../index.php');
  }
  header('Location: ?themes');
 }
 // Available themes.
 if (isset($themes)) {
  echo '<div class="clear"></div><br />
  '.$L['avail'].' '.$L['themes'].':<br />';
  foreach ($themes as $key => $thname) {
   echo "\n".'<form class="theme" method="post" action="?themes=&name='.$thname.'">
   <img src="../th-themes/'.$thname.'/'.$thname.'.png" alt="'.$L['no'].' '.$L['preview'].'" />
   <input type="submit" name="set" value="'.$L['set'].' '.$thname.'" /><br />
   <input type="button" value="'.$L['remove'].'" onclick="tog(\''.$key.'\')" />
   <input style="display:none;" id="'.$key.'" class="themecnfrm" type="submit" name="rmfolder" value="'.$L['confirm'].' '.$L['remove'].'" />
   </form>';
  }
 }
 // Other folders and files.
 if (isset($files)) {
  echo '<div class="clear"></div><br />
  '.$L['themefiles'].':<br />';
  foreach ($files as $key => $file) {
   $slash = (is_dir('../th-themes/'.$file) ? '/' : '');
   echo "\n".'<form class="files" method="post" action="?themes=&name='.$file.'">
   <img src="../th-themes/'.$file.'" alt="" />
   <input type="button" value="'.$L['remove'].' '.$file.$slash.'" onclick="tog(\'f'.$key.'\')" />
   <input style="display:none;" id="f'.$key.'" class="filecnfrm" type="submit" name="'.($slash ? 'rmfolder' : 'rmfile').'" value="'.$L['confirm'].' '.$L['remove'].'" />
   </form>';
  }
 }
 echo "\n".'</div><!--/themes-->';
}
break;

// SETTINGS
case 'settings':
if (isset($_POST['remove'])) mysql_query("DELETE FROM ".$pre."settings WHERE id=$_GET[uid]").header('refresh:00;url=?settings');
if (isset($_POST['updatesite'])) {
 $comallow = (empty($_POST['comallow']) ? '1' : '');
 $postby = (empty($_POST['postby']) ? '' : '1');
 $loginu = (empty($_POST['loginu']) ? '' : '1');
 $settings = array('baseurl'=>clean($_POST['baseurl']), 'pagi'=>clean($_POST['pagi']), 'postby'=>$postby, 'datestyle'=>clean($_POST['dstyle']), 'comallow'=>$comallow, 'notify'=>clean($_POST['notify']), 'loginu'=>$loginu);
 foreach ($settings as $setting => $value) mysql_query("UPDATE ".$pre."settings SET value='$value' WHERE setting='$setting'");
 mysql_query("UPDATE ".$pre."settings SET value='".clean($_POST['sitename'])."', meta1='".clean($_POST['desc'])."', meta2='".clean($_POST['kwords'])."', xtra='".clean($_POST['tagline'])."' WHERE setting='site'");
 mysql_query("UPDATE ".$pre."settings SET value='".htmlspecialchars($_POST['comquestion'])."', meta1='".clean($_POST['comanswer'])."' WHERE setting='comask'");
 header('refresh:00;url=?settings');
}
if (isset($_POST['adduser']) || isset($_POST['updateuser'])) {
 $error = '';
 $pass = md5(clean($_POST['pass']));
 $passchk = mysql_fetch_assoc(mysql_query("SELECT id FROM ".$pre."settings WHERE value='$pass'"));
 if ($passchk) $error .= $L['errpassexist'].'<br />';
 if ($_POST['pass'] !== $_POST['pass2']) $error .= $L['errpassmatch'].'<br />';
 if (!$_POST['user']) $error .= $L['errusrfield'].'<br />';
 if ($error) {
  echo '<pre>'.$error.'</pre><br />';
 } elseif (isset($_POST['adduser'])) {
  mysql_query("INSERT INTO ".$pre."settings VALUES ('', '".clean($_POST['user'])."', '$pass', '".clean($_POST['name'])."', '".clean($_POST['email'])."', '$_GET[group]')");
  header('refresh:00;url=?settings');
 } else {
  if (!$_POST['pass']) $pass = $_GET['upas'];
  $group = (isset($_POST['group']) ? $_POST['group'] : $_GET['group']);
  mysql_query("UPDATE ".$pre."settings SET setting='".clean($_POST['user'])."', value='$pass', meta1='".clean($_POST['name'])."', meta2='".clean($_POST['email'])."', xtra='$group' WHERE id='$_GET[uid]'");
  header('refresh:00;url=?settings');
 }
}
// Site settings.
if ($_SESSION['user']['group'] === 'u_1' || $_SESSION['user']['group'] === 'u_2') {
 echo '<h3>'.$L['site'].' '.$L['settings'].'</h3>
 <form class="setform" method="post" action="">
 <div class="setleft">
 <input type="checkbox"'.($S['loginu']['value'] ? ' checked' : '').' name="loginu" /> '.$L['loginu'].'<br />
 <input type="checkbox"'.($S['comallow']['value'] ? '' : ' checked').' name="comallow" /> '.$L['modcom'].'<br />
 <input type="checkbox"'.($S['postby']['value'] ? ' checked' : '').' name="postby" /> "'.$L['posted'].' '.$L['by'].'"<br />
 <input type="text" style="width:18px;" name="pagi" value="'.$S['pagi']['value'].'" /> '.$L['pagi'].'<br />
 <input type="text" style="width:80px;" name="dstyle" value="'.$S['datestyle']['value'].'" /> <a href="http://php.net/manual/en/function.date.php" target="_blank">'.$L['datestyle'].'</a><br /><br />
 <input type="submit" name="updatesite" value="'.$L['update'].'" />
 </div>
 <div class="setright">
 '.$L['baseurl'].': <input type="text" name="baseurl" value="'.$S['baseurl']['value'].'" /><br />
 '.$L['site'].' '.$L['name'].': <input type="text" name="sitename" value="'.$S['site']['value'].'" /><br />
 '.$L['desc'].': <input type="text" name="desc" value="'.$S['site']['meta1'].'" /><br />
 '.$L['kwords'].' (csv): <input type="text" name="kwords" value="'.$S['site']['meta2'].'" /><br />
 '.$L['tagline'].': <input type="text" name="tagline" value="'.$S['site']['xtra'].'" /><br />
 '.$L['notify'].' (csv): <input type="text" name="notify" value="'.$S['notify']['value'].'" /><br />
 '.$L['comquestion'].': <input type="text" name="comquestion" value="'.$S['comask']['value'].'" /><br />
 '.$L['comanswer'].': <input type="text" name="comanswer" value="'.$S['comask']['meta1'].'" />
 </div>
 </form><div class="clear"></div><br /><br />
 <h3>'.$L['user'].' '.$L['settings'].'</h3>
 <a class="setlink" href="?settings=3">'.$L['add'].' '.$L['user'].'</a>';
 if ($_SESSION['user']['group'] === 'u_1') echo ' <a class="setlink" href="?settings=2">'.$L['add'].' '.$L['admin'].'</a>';
 // Add user.
 if ($_GET['settings'] === '2' || $_GET['settings'] === '3') {
  echo '<br />'.$L['adding'].' '.($_GET['settings'] === '2' ? $L['admin'] : $L['user']).'<br />
  <form class="adduser" method="post" action="?settings=&group='.($_GET['settings'] === '2' ? 'u_2' : 'u_3').'">
  '.$L['name'].': <input type="text" name="name" autofocus /><br />
  '.$L['user'].': <input type="text" name="user" /><br />
  '.$L['pass'].': <input type="password" name="pass" /><br />
  '.$L['pass'].': <input type="password" name="pass2" /><br />
  '.$L['email'].': <input type="text" name="email" /><br />
  <input type="submit" name="adduser" value="'.$L['save'].'" />
  </form><div class="clear"></div>';
 }
}
// User accounts.
foreach ($U as $k => $u) {
 if ($_SESSION['user']['group'] === 'u_1' || $_SESSION['user']['id'] === $k || ($_SESSION['user']['group'] === 'u_2' && $u['group'] === 'u_3')) {
  echo "\n".'<form class="setform" method="post" action="?settings=&uid='.$k.'&upas='.$u['pass'].'&group='.$u['group'].'">
  <div class="setleft">
  <span><b>'.$u['name'].'</b><br /><i>';
  if ($u['group'] === 'u_1') echo $L['ugrp1'].' ';
  if ($u['group'] !== 'u_1' && $_SESSION['user']['group'] === 'u_1') {
   echo '<input type="radio" name="group" value="u_2" '.($u['group'] === 'u_2' ? 'checked ' : '').'/> '.$L['admin'].' &nbsp; &nbsp;
   <input type="radio" name="group" value="u_3" '.($u['group'] === 'u_3' ? 'checked ' : '').'/> '.$L['user'];
  } else {
   echo ($u['group'] === 'u_3' ? $L['user'] : $L['admin']);
  }
  echo '</i></span>
  <input type="submit" name="updateuser" value="'.$L['update'].'" />';
  if ($_SESSION['user']['id'] !== $k) {
   echo ' <input type="button" value="'.$L['remove'].'" onclick="tog(\''.$k.'\')" />
   <input style="display:none;" id="'.$k.'" class="usercnfrm" type="submit" name="remove" value="'.$L['confirm'].'" />';
  }
  echo '</div>
  <div class="setright">
  '.$L['name'].': <input type="text" name="name" value="'.$u['name'].'" /><br />
  '.$L['user'].': <input type="text" name="user" value="'.$u['user'].'" /><br />
  '.$L['new'].' '.$L['pass'].': <input type="password" name="pass" /><br />
  '.$L['new'].' '.$L['pass'].': <input type="password" name="pass2" /><br />
  '.$L['email'].': <input type="text" name="email" value="'.$u['email'].'" />
  </div>
  </form><div class="clear"></div><br />';
 }
}
// Other settings.
if ($_SESSION['user']['group'] === 'u_1' || $_SESSION['user']['group'] === 'u_2') {
 echo '<br /><h3>'.$L['other'].' '.$L['settings'].'</h3>
 <a class="setlink" href="?settings=4">'.$L['sitemap'].'</a> <a class="setlink" href="?settings=5">'.$L['backup'].'</a> <a class="setlink" href="?settings=6">'.$L['chkcur'].'</a>';
 if (is_file('install.php')) {
  echo ' <a class="setlink" href="?settings=7">'.$L['remove'].' install.php</a>';
  if ($_REQUEST['settings'] === '7') unlink('install.php').header('refresh:00;url=?settings');;
 }
 if ($_REQUEST['settings'] === '4') {
  $site = 'http://'.$_SERVER['HTTP_HOST'].$S['baseurl']['value'];
  $freq = '<changefreq>weekly</changefreq></url>'."\n";
  $xml = '<?xml version="1.0" encoding="UTF-8"?>'."\n".'<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">'."\n".'<url><loc>'.$site.'</loc><lastmod>'.date('Y-m-d').'</lastmod>'.$freq;
  $query = mysql_query("SELECT a.titlesef, b.namesef, c.namesef AS parent FROM ".$pre."posts a LEFT JOIN ".$pre."categories b ON b.id=a.category LEFT JOIN ".$pre."categories c ON c.id=b.subcat WHERE a.pub=1 ORDER BY a.id DESC");
  while ($r = mysql_fetch_assoc($query)) {
   $cat = $r['namesef'] ? $r['namesef'].'/' : '';
   if ($r['parent']) $cat = $r['parent'].'/'.$cat;
   $xml .= '<url><loc>'.$site.$cat.$r['titlesef'].'</loc>'.$freq;
  }
  $xml .= '</urlset>';
  $map = fopen('../sitemap.xml', 'w');
  fwrite($map, $xml);
  fclose($map);
  echo '<pre>'.$L['done'];
  $robots = file_get_contents('../robots.txt');
  if (!strpos($robots, $site.'sitemap.xml')) echo '<br /><i>'.$L['updaterobots'].'</i><br />Sitemap: '.$site.'sitemap.xml';
  echo '</pre>';
 }
 if ($_REQUEST['settings'] === '5') {
  $sqlname = $dbname.'-'.date("mdy").'.sql.gz';
  $tables = '';
  $table = mysql_query("SHOW TABLES FROM ".$dbname." LIKE '".$pre."%'");
  while ($t = mysql_fetch_assoc($table)) $tables .= $t['Tables_in_'.$dbname.' ('.$pre.'%)'].' ';
  system("mysqldump -u$dbuser -p$dbpass $dbname $tables| gzip > $sqlname");
  echo '<pre><b><i>'.$dbname.'</i></b> '.$L['dbbackup'].' <a href="'.$sqlname.'">..'.dirname($_SERVER['REQUEST_URI']).'/'.$sqlname.'</a></pre>';
 }
 if ($_REQUEST['settings'] === '6') {
  $ver = file_get_contents(clean('http://repository.theocms.com/version.txt'));
  echo '<pre>'.($ver === FALSE ? $L['errchkcur'] : $ver).'</pre> <a href="http://theocms.com/download" target="_blank">theocms.com/download</a>';
 }
}
$footlinks = '<span>v'.$S['version']['value'].'</span>';
break;

// DEFAULT VIEW
default:
echo '<div id="left">'."\n";
// Category.
$rowcat = mysql_query("SELECT a.id, a.name, b.title, c.pub FROM ".$pre."categories a LEFT JOIN ".$pre."posts b ON b.category=a.id LEFT JOIN ".$pre."posts c ON c.category=a.id AND c.pub='' WHERE a.subcat=0 GROUP BY a.id");
while ($cat = mysql_fetch_assoc($rowcat)) {
 echo '<div class="category">
 <a class="catname"'.($cat['title'] ? ' style="cursor:pointer;"' : '').' onclick="tog(\''.$cat['id'].'\')">'.$cat['name'].'</a>
 <span>'.($cat['pub'] === '' ? $L['cdraft'].' ' : '').'<a href="?post='.$cat['id'].'">'.$L['post'].'</a> <a href="?cat=&edit='.$cat['id'].'">'.$L['edit'].'</a></span><br />'."\n";
 // Posts for category.
 if ($cat['title']) {
  echo '<div style="display:none;" id="'.$cat['id'].'" class="catposts">'."\n";
  $rowpost = mysql_query("SELECT id, pub, title, editby FROM ".$pre."posts WHERE category=$cat[id] ORDER BY id DESC");
  while ($post = mysql_fetch_assoc($rowpost)) {
   if ($_SESSION['user']['group'] === 'u_3' && $_SESSION['user']['id'] === $post['editby']) echo '* ';
   echo '<a href="?post=&edit='.$post['id'].'"'.($post['pub'] ? '' : ' class="postdraft"').'>'.$post['title'].'</a><br />'."\n";
  }
  echo '</div><!--/catposts-->'."\n";
 }
 // Subcategories for category.
 $rowsubcat = mysql_query("SELECT a.id, a.name, b.title, c.pub FROM ".$pre."categories a LEFT JOIN ".$pre."posts b ON b.category=a.id LEFT JOIN ".$pre."posts c ON c.category=a.id AND c.pub='' WHERE a.subcat=$cat[id] GROUP BY a.id");
 while ($subcat = mysql_fetch_assoc($rowsubcat)) {
  echo '<a class="subcatname"'.($subcat['title'] ? ' style="cursor:pointer;"' : '').' onclick="tog(\''.$subcat['id'].'\')">'.$subcat['name'].'</a>
  <span>'.($subcat['pub'] === '' ? $L['cdraft'].' ' : '').'<a href="?post='.$subcat['id'].'">'.$L['post'].'</a> <a href="?cat=&edit='.$subcat['id'].'">'.$L['edit'].'</a></span><br />'."\n";
  // Posts for subcategory.
  if ($subcat['title']) {
   echo '<div style="display:none;" id="'.$subcat['id'].'" class="subcatposts">'."\n";
   $rowsubpost = mysql_query("SELECT id, pub, title, editby FROM ".$pre."posts WHERE category=$subcat[id] ORDER BY id DESC");
   while ($subpost = mysql_fetch_assoc($rowsubpost)) {
    if ($_SESSION['user']['group'] === 'u_3' && $_SESSION['user']['id'] === $subpost['editby']) echo '* ';
    echo '<a href="?post=&edit='.$subpost['id'].'"'.($subpost['pub'] ? '' : ' class="postdraft"').'>'.$subpost['title'].'</a><br />'."\n";
   }
   echo '</div><!--/subcatposts-->'."\n";
  }
 }
 echo '</div><!--/category-->'."\n".'<br />'."\n";
}
// Pages.
$rowpchk = mysql_query("SELECT pub, title FROM ".$pre."posts WHERE category=0");
while ($pchk = mysql_fetch_assoc($rowpchk)) {
 if ($pchk['pub'] === '') $pchkpub = $L['cdraft'].' ';
 if ($pchk['title']) $pchktitle = ' style="cursor:pointer;"';
}
if (empty($pchkpub)) $pchkpub = '';
if (empty($pchktitle)) $pchktitle = '';
echo '<div class="category">
<a class="catname"'.$pchktitle.' onclick="tog(\'pages\')">'.$L['pages'].'</a>
<span>'.$pchkpub.'<a href="?post">'.$L['post'].'</a></span><br />'."\n";
if ($pchktitle) {
 echo '<div style="display:none;" id="pages" class="catposts">';
 $rowpage = mysql_query("SELECT id, pub, title FROM ".$pre."posts WHERE category=0 ORDER BY id DESC");
 while ($page = mysql_fetch_assoc($rowpage)) {
  echo '<a href="?post=&edit='.$page['id'].'"'.($page['pub'] ? '' : ' class="postdraft"').'>'.$page['title'].'</a><br />'."\n";
 }
 echo '</div><!--/catposts-->'."\n";
}
echo '</div><!--/category--><br />
</div><!--/left-->'."\n";
// New category, search and optional display items.
echo '<div id="right">
<form method="post" action="?search"><input type="text" name="search" value="'.$L['search'].'" onclick="value=\'\'" /></form>
<form method="post" action="?cat=&subid=0"><input type="text" name="catname" value="'.$L['new'].' '.$L['cat'].'" onclick="value=\'\'" /></form>
<div class="clear"></div>
<div class="optdisp">'.$optdisp.'</div>
</div><!--/right-->';
break;
} // End panel switch.

// FOOT LINKS
echo "\n".'<div class="clear"></div>
</div><!--/container-->
<div id="foot">&nbsp;'.$footlinks.'</div>
</div><!--/wrap-->'."\n";

// JAVASCRIPT
?><script type="text/javascript">function tog(id){d=document.getElementById(id);d.style.display=((d.style.display!='none')?'none':'block');}function ins(st,en){e=document.getElementById('body');sel=e.value.substring(e.selectionStart,e.selectionEnd);en=(en?en:'');switch(st){case'up':f=document.getElementById('upfile').files[0].name;src='<?php if(isset($dir)) echo $dir;?>/'+f;if(f.match(/\.(png|jpg|jpeg|svg|gif|tif|tiff)$/)){intro=confirm("<?php echo $L['jsIntro'];?>");if(intro==false)en='</a>';img=confirm("<?php echo $L['jsImg'];?>");css=(img?'image':'thumb');alt=prompt("<?php echo $L['jsImgAlt'];?>");if(alt==null)return;st='<img src="'+src+'" class="'+css+'" alt="'+alt+'" /\>';}else{ftxt=prompt("<?php echo $L['jsLink'];?>");if(ftxt==null)return;st='<a href="'+src+'">'+ftxt+'</a>';}break;case'add':func=prompt("<?php echo $L['avail'].':\n\n';if(isset($plugins)){foreach($plugins as $p)if(isset($p['addin']))echo $p['addinstruct'].'\n\n';}else{echo $L['none'];}?>");st=(func?'[ADD]'+func+'[/ADD]':'');break;case'link':url=prompt("<?php echo $L['url'];?>:",'http://');if(url==null)return;txt=(!sel?prompt("<?php echo $L['jsLink'];?>"):'');if(txt==null)return;st='<a href="'+url+'" target="_blank" rel="nofollow">'+txt;en='</a>';break;}e.value=e.value.substring(0,e.selectionStart)+st+sel+en+e.value.substring(e.selectionEnd,e.value.length);e.focus();}</script><?php

// END AUTHENTICATED CONTENT, LOGIN
} else {
 $autof = ($S['loginu']['value'] ? '' : ' autofocus');
 echo '<div id="loginbox"><div id="login">
 <h2>'.$S['site']['value'].'</h2>
 <form method="post">
 '.($autof ? $L['login'].'<br /><br />' : $L['user'].'<br /><input type="text" maxlength="25" name="loginuser" autofocus /><br /><br />'.$L['pass'].'<br />').'
 <input type="password" name="loginpass" maxlength="25"'.$autof.' />
 <input type="submit" style="display:none;" />
 </form>
 </div></div>';
}

// CATEGORY DROPDOWN
function dropdown($id = '', $addsubs = '', $dropdown = '') {
 global $pre, $L;
 $row = mysql_query("SELECT id, name FROM ".$pre."categories WHERE subcat=0 ORDER BY id");
 while ($opt = mysql_fetch_assoc($row)) {
  $dropdown = $dropdown.'<option value="'.$opt['id'].'"'.($opt['id'] === $id ? ' selected' : '').'>'.$opt['name'].'</option>';
  if ($addsubs === 'addsubs') {
   $rowsub = mysql_query("SELECT id, name FROM ".$pre."categories WHERE subcat=$opt[id] ORDER BY id");
   while ($optsub = mysql_fetch_assoc($rowsub)) {
    $dropdown = $dropdown.'<option value="'.$optsub['id'].'"'.(($optsub['id'] === $id) ? ' selected' : '').'>&nbsp;'.$optsub['name'].'</option>';
   }
  }
 }
 if ($addsubs === 'addsubs') $dropdown = $dropdown.'<option style="font-style:italic;" value="0"'.($id === '0' ? ' selected' : '').'>'.$L['page'].'</option>';
 return '<select name="category">'.$dropdown.'</select>';
}

// POST FORM
function form($pub, $title, $text, $catid, $mdesc, $mkwords, $tags, $date, $showcom, $dir, $sef, $editby) {
 global $L;
 if (empty($_GET['edit'])) $_GET['edit'] = '';
 echo '<form class="edit" method="post" enctype="multipart/form-data" action="?post=&edit='.$_GET['edit'].'">
 '.$L['title'].' <input type="text" name="title" value="'.$title.'" autofocus />
 <span>'.$L['imgfile'].' <input type="file" id="upfile" name="upfile" onchange="ins(\'up\')" /></span>
 <textarea id="body" name="text" rows="21" cols="">'.$text.'</textarea>
 <div class="buttons">
 <input type="button" value="'.$L['intro'].'" onclick="ins(\'[INTRO]\')" /><br /><br />
 <input type="button" value="'.$L['linebr'].'" onclick="ins(\'<br />\')" /><br />
 <input type="button" value="'.$L['head'].'" onclick="ins(\'<h4>\',\'</h4>\')" /><br />
 <input type="button" value="'.$L['link'].'" onclick="ins(\'link\')" /><br />
 <input type="button" value="'.$L['pre'].'" onclick="ins(\'<pre>\',\'</pre>\')" /><br />
 <input type="button" value="'.$L['capt'].'" onclick="ins(\'<div class=&quot;caption&quot;>\',\'</div>\')" /><br />
 <input type="button" value="'.$L['quot'].'" onclick="ins(\'<q>\',\'</q>\')" /><br />
 <input type="button" value="'.$L['ital'].'" onclick="ins(\'<i>\',\'</i>\')" /><br />
 <input type="button" value="'.$L['bold'].'" onclick="ins(\'<b>\',\'</b>\')" /><br />
 <input type="button" value="'.$L['addin'].'" onclick="ins(\'add\')" /><br /><br />';
 if ($_SESSION['user']['group'] === 'u_1' || $_SESSION['user']['group'] === 'u_2' || $_SESSION['user']['id'] === $editby) echo '<input type="submit" name="save" value="'.$L['save'].'" />';
 echo '</div><!--/buttons-->
 <div class="clear"></div>
 <div class="editfleft">
 '.$L['tags'].' (csv) <input type="text" name="tags" value="'.$tags.'" /><br />
 '.$L['desc'].' <input type="text" name="desc" value="'.$mdesc.'" /><br />
 '.$L['kwords'].' (csv) <input type="text" name="kwords" value="'.$mkwords.'" />
 </div>
 <div class="editfmid">
 '.$L['change'].' '.$L['cat'].':<br />'.dropdown($catid, 'addsubs').'<br />';
 if ($_GET['edit']) echo $L['date'].':<br /><input type="text" name="date" value="'.$date.'" />';
 echo '</div>
 <div class="editfright">
 <input type="checkbox" name="showcom"'.($showcom ? ' checked' : '').' /> '.($_GET['edit'] ? '<a href="?commod='.$_GET['edit'].'">'.$L['comments'].'</a>' : $L['comments']).'<br />
 <input type="checkbox" name="pub"'.($pub ? ' checked' : '').' /> '.$L['pub'].'<br />';
 if ($_GET['edit']) echo '<a class="editpreview" href="'.$sef.'&preview_key='.substr($_COOKIE['PHPSESSID'], 17).'" target="_blank">'.$L['preview'].'</a><br />';
 if ($_GET['edit'] && $_SESSION['user']['group'] === 'u_1' || $_SESSION['user']['group'] === 'u_2') echo '<a style="cursor:pointer;" class="editrem" onclick="tog(\'rmwarn\')">'.$L['remove'].'</a>';
 echo '</div>
 <div style="display:none;" class="rmconf" id="rmwarn">'.$L['remwarn'].' <input type="submit" name="remove" value="'.$L['confirm'].'" /></div>
 <input type="hidden" name="dir" value="'.$dir.'" />
 </form>';
}
?>

</body></html>